module Board.Board(
    Board(..),
    coordinateIsValid,
    printBoard,
    boardToString,
    numCellsInBoard
)where

import Board.Cell(
    Cell(..),
    Coordinate(..),
    printCell)

type Board = [[Cell]]

coordinateIsValid :: Board -> Coordinate -> Bool
coordinateIsValid [] _ = False
coordinateIsValid board coordinate
    | x < 0 = False
    | x >= height = False
    | y < 0 = False
    | y >= width = False
    |otherwise = True
    where   height = length board
            width = length (head board)
            x = fst coordinate
            y = snd coordinate

_printRow :: [Cell] -> IO ()
_printRow [] = return ()
_printRow (head:tail) =
    do
        printCell head
        _printRow tail

printBoard :: Board -> IO ()
printBoard [] = return ()
printBoard (head:tail) = do
    _printRow head
    putStrLn " "
    printBoard tail

boardToString :: Board -> String
boardToString [] = ""
boardToString (head:tail) =
    _rowToString head ++ "\n" ++ boardToString tail

_rowToString :: [Cell] -> String
_rowToString = concatMap show

numCellsInBoard :: Board -> Int
numCellsInBoard = foldr ((+) . length) 0