{-# LINE 1 "ExportTypes.hsc" #-}
{-# LANGUAGE ForeignFunctionInterface #-}
{-# LANGUAGE CPP                      #-}

module ExportTypes where

import Foreign
import Foreign.C

import Control.Applicative
import Control.Monad



data SCell = SCell{
    rPos::CInt,
    cPos::CInt,
    num::CInt,
    sType::CChar
} deriving(Show)

instance Storable SCell where
    sizeOf _ = (16)
{-# LINE 23 "ExportTypes.hsc" #-}
    alignment _ = 4
{-# LINE 24 "ExportTypes.hsc" #-}
    peek ptr = do
        rPos <- (\hsc_ptr -> peekByteOff hsc_ptr 0) ptr
{-# LINE 26 "ExportTypes.hsc" #-}
        cPos <- (\hsc_ptr -> peekByteOff hsc_ptr 4) ptr
{-# LINE 27 "ExportTypes.hsc" #-}
        num  <- (\hsc_ptr -> peekByteOff hsc_ptr 8) ptr
{-# LINE 28 "ExportTypes.hsc" #-}
        sType <- (\hsc_ptr -> peekByteOff hsc_ptr 12) ptr
{-# LINE 29 "ExportTypes.hsc" #-}
        return SCell{rPos=rPos, cPos=cPos, num=num, sType=sType}
    poke ptr SCell{rPos=rPos, cPos=cPos, num=num, sType=sType} = do
        (\hsc_ptr -> pokeByteOff hsc_ptr 0) ptr rPos
{-# LINE 32 "ExportTypes.hsc" #-}
        (\hsc_ptr -> pokeByteOff hsc_ptr 4) ptr cPos
{-# LINE 33 "ExportTypes.hsc" #-}
        (\hsc_ptr -> pokeByteOff hsc_ptr 8) ptr num
{-# LINE 34 "ExportTypes.hsc" #-}
        (\hsc_ptr -> pokeByteOff hsc_ptr 12) ptr sType
{-# LINE 35 "ExportTypes.hsc" #-}



data SBoard = SBoard{
    sHeight::CInt,
    sWidth::CInt,
    sUnsolvedBoard::Ptr (Ptr SCell),
    sSolvedBoard::Ptr (Ptr SCell)
}

instance Storable SBoard where
    sizeOf _ = (24)
{-# LINE 47 "ExportTypes.hsc" #-}
    alignment _ = 8
{-# LINE 48 "ExportTypes.hsc" #-}
    peek ptr = do
        sHeight <- (\hsc_ptr -> peekByteOff hsc_ptr 0) ptr
{-# LINE 50 "ExportTypes.hsc" #-}
        sWidth <- (\hsc_ptr -> peekByteOff hsc_ptr 4) ptr
{-# LINE 51 "ExportTypes.hsc" #-}
        sUnsolvedBoard <- (\hsc_ptr -> peekByteOff hsc_ptr 8) ptr
{-# LINE 52 "ExportTypes.hsc" #-}
        sSolvedBoard <- (\hsc_ptr -> peekByteOff hsc_ptr 16) ptr
{-# LINE 53 "ExportTypes.hsc" #-}
        return SBoard{sHeight=sHeight, sWidth=sWidth, sUnsolvedBoard=sUnsolvedBoard, sSolvedBoard=sSolvedBoard}
    poke ptr SBoard{sHeight=sHeight, sWidth=sWidth, sUnsolvedBoard=sUnsolvedBoard, sSolvedBoard=sSolvedBoard} = do
        (\hsc_ptr -> pokeByteOff hsc_ptr 0) ptr sHeight
{-# LINE 56 "ExportTypes.hsc" #-}
        (\hsc_ptr -> pokeByteOff hsc_ptr 4) ptr sWidth
{-# LINE 57 "ExportTypes.hsc" #-}
        (\hsc_ptr -> pokeByteOff hsc_ptr 8) ptr sUnsolvedBoard
{-# LINE 58 "ExportTypes.hsc" #-}
        (\hsc_ptr -> pokeByteOff hsc_ptr 16) ptr sSolvedBoard