{-# LANGUAGE ForeignFunctionInterface #-}
{-# LANGUAGE CPP                      #-}

module ExportTypes where

import Foreign
import Foreign.C

import Control.Applicative
import Control.Monad

#include "ExportTypes.h"

data SCell = SCell{
    rPos::CInt,
    cPos::CInt,
    num::CInt,
    sType::CChar
} deriving(Show)

instance Storable SCell where
    sizeOf _ = #{size sCell}
    alignment _ = #{alignment sCell}
    peek ptr = do
        rPos <- #{peek sCell, rPos} ptr
        cPos <- #{peek sCell, cPos} ptr
        num  <- #{peek sCell, num} ptr
        sType <- #{peek sCell, sType} ptr
        return SCell{rPos=rPos, cPos=cPos, num=num, sType=sType}
    poke ptr SCell{rPos=rPos, cPos=cPos, num=num, sType=sType} = do
        #{poke sCell, rPos} ptr rPos
        #{poke sCell, cPos} ptr cPos
        #{poke sCell, num} ptr num
        #{poke sCell, sType} ptr sType



data SBoard = SBoard{
    sHeight::CInt,
    sWidth::CInt,
    sUnsolvedBoard::Ptr (Ptr SCell),
    sSolvedBoard::Ptr (Ptr SCell)
}

instance Storable SBoard where
    sizeOf _ = #{size sBoard}
    alignment _ = #{alignment sBoard}
    peek ptr = do
        sHeight <- #{peek sBoard, height} ptr
        sWidth <- #{peek sBoard, width} ptr
        sUnsolvedBoard <- #{peek sBoard, unsolvedBoard} ptr
        sSolvedBoard <- #{peek sBoard, solvedBoard} ptr
        return SBoard{sHeight=sHeight, sWidth=sWidth, sUnsolvedBoard=sUnsolvedBoard, sSolvedBoard=sSolvedBoard}
    poke ptr SBoard{sHeight=sHeight, sWidth=sWidth, sUnsolvedBoard=sUnsolvedBoard, sSolvedBoard=sSolvedBoard} = do
        #{poke sBoard, height} ptr sHeight
        #{poke sBoard, width} ptr sWidth
        #{poke sBoard, unsolvedBoard} ptr sUnsolvedBoard
        #{poke sBoard, solvedBoard} ptr sSolvedBoard