module Nurikabe.Medium(
    mediumStep
)where

import Board.Board(Board)
import Board.Monitor(Monitor(..), (>\=))

import Techniques.Complete(complete)
import Techniques.Separate(separate)
import Techniques.Expand(expand)
import Techniques.Surround(surround)
import Techniques.AvertPools(avertPools)
import Techniques.Unreachable(unreachable)

mediumStep :: Board -> Monitor Board
mediumStep [] = Unchanged []
mediumStep board =
    let
        completedBoard = complete board
        separatedBoard = completedBoard >\= separate
        expandedBoard = separatedBoard >\= expand
        surroundedBoard = expandedBoard >\= surround
        poolAvertedBoard = surroundedBoard >\= avertPools
        unreachableBoard = poolAvertedBoard >\= unreachable
        result = unreachableBoard
    in
        result
