module Nurikabe.Nurikabe(
    easySolve,
    mediumSolve,
    hardSolve
)where

import Board.Board (Board)
import Board.Monitor(Monitor(..))
import Region.Region (findAllGreyCells)

import Nurikabe.Easy(easyStep)
import Nurikabe.Medium(mediumStep)

easySolve :: Board -> Int -> (Board, Int)
easySolve [] steps = ([], steps)
easySolve board steps
    | numGreyCells == 0 = (board, steps) --Solved
    | otherwise =
        let
            step = easyStep board
        in case step of
          Changed b -> easySolve b $ steps+1
          Unchanged b -> ([], steps) -- Unsolvable
    where
        numGreyCells = length $ findAllGreyCells board


mediumSolve :: Board -> Int -> (Board, Int)
mediumSolve [] steps = ([], steps)
mediumSolve board steps
    | numGreyCells == 0 = (board, steps) --Solved
    | otherwise =
        let
            step = mediumStep board
        in 
            case step of
                Changed b -> mediumSolve b $ steps+1
                Unchanged b -> ([], steps) -- Unsolvable

    where
        numGreyCells = length $ findAllGreyCells board

hardSolve :: Board -> Int -> (Board, Int)
hardSolve [] _ = ([], 0)
hardSolve board steps = ([], 0) -- to be implemented



    