module Techniques.AvertPools(
    avertPools
)where

import Board.Cell (Cell(position), Coordinate)
import Board.Board(Board)
import Board.Monitor(Monitor(..), (>\\=))
import Board.Modifier(whiten)

import Region.Region(isCellPotentialPool, findAllGreyCells)

avertPools :: Board -> Monitor Board
avertPools [] = Unchanged []
avertPools board =
    let
        greyCellCoords = map position $ findAllGreyCells board
    in
        _markPotentialPools greyCellCoords board

_markPotentialPools :: [Coordinate] -> Board -> Monitor Board
_markPotentialPools _ [] = Unchanged []
_markPotentialPools [] board = Unchanged board
_markPotentialPools (head:tail) board =
    let
        modifiedBoard = _markPotentialPool board head
    in
        modifiedBoard >\\= _markPotentialPools tail


_markPotentialPool :: Board -> Coordinate -> Monitor Board
_markPotentialPool [] _ = Unchanged []
_markPotentialPool board coordinate =
    if isCellPotentialPool board coordinate then
        Changed $ whiten board [coordinate]
    else
        Unchanged board