module Techniques.Separate(
    separate
)where

import Board.Cell(Cell(..), cellIsGrey)
import Board.Board(Board)
import Board.Monitor(Monitor(..))
import Board.Modifier(blacken)

import Region.Island(Island, findNumberedIslands, findAllCommonBorderCells)

separate :: Board -> Monitor Board 
separate [] = Unchanged []
separate board = separateIslands (findNumberedIslands board) board


separateIslands :: [Island] -> Board -> Monitor Board
separateIslands _ [] = Unchanged []
separateIslands [] board = Unchanged board
separateIslands islands board = let
        borderCells = [cell | cell <- findAllCommonBorderCells board islands, cellIsGrey cell]
        modified = not $ null borderCells
        newBoard = blacken board (map position borderCells)
    in
        if modified then
            Changed newBoard
        else
            Unchanged board