module Test.AvertPools(
    testAvertPools
)where

import Techniques.AvertPools(avertPools)
import Board.Generator (generateGreyBoard)
import Board.Modifier (blacken)
import Board.Board(printBoard)
import Board.Monitor(extract)

testAvertPools :: IO()
testAvertPools =
    let
        baseBoard = generateGreyBoard (5,5)
        markedBoard = blacken baseBoard [(0, 1), (0, 3), (1, 0), (1, 1), (1, 2), (1, 3), (3, 4), (4, 3), (4, 4)]
        poolAvertedBoard = extract $ avertPools markedBoard
    in do
        printBoard baseBoard
        putStrLn ""
        printBoard markedBoard
        putStrLn ""
        printBoard poolAvertedBoard
        putStrLn ""