module Test.Complete(
    testComplete
)where

import Board.Board(printBoard)
import Board.Monitor(extract)
import Board.Generator(generateGreyBoard)
import Board.Modifier(whiten, placeNumber)

import Region.Region(discoverFullRegion)

import Techniques.Complete(complete)

testComplete :: IO()
testComplete =
    let
        board = generateGreyBoard (4, 4)
        newBoard = whiten board [(0,0), (0,1), (0,2), (1,0), (1,1)]
        numberedBoard = placeNumber newBoard 5 (1,1)
        region = discoverFullRegion newBoard [head (head newBoard)]
        numberedregion = discoverFullRegion numberedBoard [head (head numberedBoard)]
        completeBoard = extract $ complete numberedBoard
    in do
        printBoard board
        putStrLn ""
        printBoard newBoard
        putStrLn ""
        printBoard numberedBoard
        putStrLn ""
        print region
        putStrLn  ""
        print numberedregion
        putStrLn ""
        printBoard completeBoard