module Test.Expand(
    testExpand
)where

import Board.Board(printBoard)
import Board.Monitor(extract)
import Board.Generator(generateGreyBoard)
import Board.Modifier(blacken, whiten, placeNumber)

import Techniques.Expand(expand)
import Techniques.Complete(complete)  

testExpand :: IO()
testExpand = 
    let
        baseBoard = generateGreyBoard (4, 4)
        numberedBoard = placeNumber (placeNumber baseBoard 2 (1,1)) 3 (2,2) --insertCell (insertCell baseBoard Cell {position=(1,1), number=Just 2, cellType=White}) Cell {position=(2,2), number=Just 3, cellType=White}
        markedBoard = whiten (blacken numberedBoard [(0,1), (1,2), (2,1), (2,3), (3,3)]) [(3,2)]
        expandedBoard = extract $ expand markedBoard
        completedBoard = extract $ complete expandedBoard
    in do
        printBoard baseBoard
        putStrLn ""
        printBoard numberedBoard
        putStrLn ""
        printBoard markedBoard
        putStrLn ""
        printBoard expandedBoard
        putStrLn ""
        printBoard completedBoard
        putStrLn ""