module Test.Nurikabe(
    testEasyGenerator,
    testMediumGenerator,
    testHardGenerator
)where

import Board.Board (printBoard)
import Board.Generator(BoardSize, Distribution)

import Nurikabe.Generator (generateEasySeededBoard, generateMediumSeededBoard, generateHardSeededBoard)

testEasyGenerator :: BoardSize -> Distribution -> Int -> IO ()
testEasyGenerator size distr seed = 
    let (unsolvedBoard, solvedBoard) = generateEasySeededBoard size distr seed
    in do
    printBoard unsolvedBoard
    putStrLn ""
    printBoard solvedBoard

testMediumGenerator :: BoardSize -> Distribution -> Int -> IO ()
testMediumGenerator size distr seed = 
    let (unsolvedBoard, solvedBoard) = generateMediumSeededBoard size distr seed
    in do
    printBoard unsolvedBoard
    putStrLn ""
    printBoard solvedBoard

testHardGenerator :: BoardSize -> Distribution -> Int -> IO ()
testHardGenerator size distr seed = 
    let (unsolvedBoard, solvedBoard) = generateHardSeededBoard size distr seed
    in do
    printBoard unsolvedBoard
    putStrLn ""
    printBoard solvedBoard
        