module Test.Surround(
    testSurround
)where

import Board.Board (printBoard)
import Board.Monitor(extract)
import Board.Generator (generateGreyBoard)
import Board.Modifier(whiten, blacken)

import Techniques.Surround(surround)

testSurround :: IO()
testSurround =
    let
        baseBoard = generateGreyBoard (5,5)
        markedBoard = blacken (whiten baseBoard [(0,1), (0,3), (1,0), (1,2), (2, 1)]) [(3, 4), (4, 3), (4, 1), (3, 2), (2, 3)]
        surroundedBoard = extract $ surround markedBoard
    in do
        printBoard baseBoard
        putStrLn ""
        printBoard markedBoard
        putStrLn ""
        printBoard surroundedBoard
        putStrLn ""