module Test.Unreachable(
    testUnreachable,
)where

import Board.Board(printBoard)
import Board.Monitor(extract)
import Board.Generator(generateGreyBoard)
import Board.Modifier(blacken, whiten, placeNumber)

import Techniques.Unreachable(unreachable)

testUnreachable :: IO()
testUnreachable =
    let
        board = generateGreyBoard (5, 5)
        numberedBoard = placeNumber (placeNumber board 5 (0,3)) 4 (4,0)
        markedBoard = blacken (whiten numberedBoard [(0, 2), (0, 4), (1, 4)]) [(3, 0)]
        unreachableBoard = extract $ unreachable markedBoard
        board2 = generateGreyBoard (4,4)
        numberedBoard2 = placeNumber (placeNumber (placeNumber board2 1 (0,3)) 1 (3,0)) 5 (2, 3)
        markedBoard2 = blacken (whiten numberedBoard2 [(1,1)]) [(0,1), (0,2), (1,2), (1,3), (2,0), (3,1)]
        unreachableBoard2 = extract $ unreachable markedBoard2
    in do
        printBoard markedBoard
        putStrLn ""
        printBoard unreachableBoard
        putStrLn ""
        printBoard markedBoard2
        putStrLn ""
        printBoard unreachableBoard2

