﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Generator.Common.Exceptions
{
    [Serializable]
    public class BoardTimeoutException : TimeoutException
    {
        public BoardTimeoutException()
            : base()
        {
        }

        public BoardTimeoutException(int timeout, int height, int width, string difficulty)
            : base($"Unable to generate solvable ({height}, {width}) board of {difficulty} difficulty. Execution timed out after {timeout} seconds.")
        {
        }

        public BoardTimeoutException(int timeout, int seed, int height, int width, string difficulty)
            : base($"Unable to generate solvable ({height}, {width}) board of {difficulty} difficulty with seed: {seed}. Execution timed out after {timeout} seconds.")
        {
        }

        public BoardTimeoutException(string message)
            : base(message)
        {
        }

        public BoardTimeoutException(string message, Exception inner)
            : base(message, inner)
        {
        }
    }
}
