﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Generator.Common.Exceptions
{
    [Serializable]
    public class UnsolvableBoardException : Exception
    {
        public int? Seed { get; }
        public int? Height { get; }
        public int? Width { get; }
        public string? Difficulty { get; }

        public UnsolvableBoardException()
            : base()
        {
        }

        public UnsolvableBoardException(int seed, int height, int width, string difficulty)
            : base($"Unsolvable board of size ({height}, {width}) and difficulty '{difficulty}' generated with seed {seed}")
        {
            Seed = seed;
            Height = height;
            Width = width;
            Difficulty = difficulty;
        }

        public UnsolvableBoardException(string message)
            : base(message)
        { 
        }

        public UnsolvableBoardException(string message, Exception inner)
            : base(message, inner)
        {
        }

    }
}
