﻿using Generator.Application.Board;

namespace Generator.Dto
{
    public class BoardDto
    {
        public int Seed { get; }
        public int Height { get; }
        public int Width { get; }
        public List<List<string>> UnsolvedBoardArray { get; }
        public List<List<string>> SolvedBoardArray { get; }

        public BoardDto(int seed, int height, int width, Board.Cell[,] unsolvedBoard, Board.Cell[,] solvedBoard)
        {
            Seed = seed;
            Height = height;
            Width = width;
            UnsolvedBoardArray = new List<List<string>>();
            SolvedBoardArray = new List<List<string>>();

            for (int i = 0; i < Height; i++)
            {
                UnsolvedBoardArray.Add(new List<string>());
                SolvedBoardArray.Add(new List<string>());

                for(int j = 0; j < Width; j++)
                {
                    UnsolvedBoardArray[i].Add(unsolvedBoard[i, j].num is null ? unsolvedBoard[i, j].type.ToString() : unsolvedBoard[i, j].num.ToString());
                    SolvedBoardArray[i].Add(solvedBoard[i, j].num is null ? solvedBoard[i, j].type.ToString() : solvedBoard[i, j].num.ToString());
                }
            }
        }
    }
}