﻿using MasterGame.Models.Boards;
using Xamarin.Forms;

namespace MasterGame
{
    public partial class App : Application
    {
        const string level = "Level";
        public string Level { get; set; } = null;

        const string board = "Board";
        public NurikabeBoard Board { get; set; } = null;
        public bool BoardInProgress
        {
            get
            {
                return !(Board is null);
            }
        }

        public App()
        {
            InitializeComponent();

            MainPage = new AppShell();
        }

        protected override void OnStart()
        {
            if (Properties.ContainsKey(board))
            {
                Board = (NurikabeBoard)Properties[board];
                Properties.Remove(board);
            }
            if (Properties.ContainsKey(level))
            {
                Level = (string)Properties[level];
                Properties.Remove(level);
            }
        }

        protected override void OnSleep()
        {
            Properties[board] = Board;
            Properties[level] = Level;
        }

        protected override void OnResume()
        {
        }

        public void ClearBoard()
        {
            Board = null;
            Level = null;
        }

        public void AddBoard(NurikabeBoard board, string level)
        {
            Board = board;
            Level = level;
        }

        
    }
}
