﻿using System;
using System.Collections.Generic;
using System.Text;
using Xamarin.Forms;

namespace MasterGame.Models.Cells
{
    public class LabelCell : Label
    {
        public (int Row, int Col) Position { get; set; }
        public (double X, double Y) Size { get; set; }

        public LabelCell((int row, int col) position, (double x, double y) size, string text, Color textColor, int? fontSize = null) : base()
        {
            Position = position;
            Size = size;

            HeightRequest = Size.Y;
            WidthRequest = Size.X;
            BackgroundColor = Color.White;

            Text = text;
            TextColor = textColor;

            FontSize = fontSize ?? Size.X/2;
            HorizontalTextAlignment = TextAlignment.Center;
            VerticalTextAlignment = TextAlignment.Center;
        }
    }
}
