﻿using MvvmHelpers;
using System.Windows.Input;
using Xamarin.Forms;

namespace MasterGame.ViewModels
{
    public class NurikabeMenuViewModel : BaseViewModel
    {
        private string _continueText;
        public string ContinueText
        {
            get => _continueText;
            set => SetProperty(ref _continueText, "Continue "+value);
        }
        public ICommand Continue { get; }
        public ICommand NewGame { get; }

        private bool _canContinue;
        public bool CanContinue
        {
            get => _canContinue;
            set => SetProperty(ref _canContinue, value);
        }
        public NurikabeMenuViewModel()
        {
            Continue = new MvvmHelpers.Commands.Command(OnContinue, IsContinuationPossible);
            NewGame = new MvvmHelpers.Commands.Command(OnNewGame);
        }

        void OnContinue()
        {
            Shell.Current.GoToAsync("NurikabeGamePage"); 
        }

        void OnNewGame()
        {
            Shell.Current.GoToAsync("NurikabeDifficultySelectionPage");
        }

        bool IsContinuationPossible()
        {
            return CanContinue;
        }
    }
}
